'''
nodold module, version 0.2

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import os,socket,re,string

class nodold(ascanner):
  def __init__(self,arg):
      self.name='NodOldD'
      self.arg=arg
  def scanfile(self,filenames,dirname=''):
      s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      s.connect((self.arg[0],self.arg[1]))
      f=s.makefile('rw',4096)
      r=f.readline() # 200 NOD32SS 1.386 (20030326)
      s.send("PARM @patt:1@heur:2@clean:0\n")
      r=f.readline() # 200 OK (patt: 1, heur: 2, clean: 0)
      ret=[]
      for file in filenames:
        s.send("SCAN "+os.path.join(dirname,file)+"\n")
        line=f.readline()
        if not re.search("^200",line):
          ret.append(line[4:])
        if re.search("^5",line): # error opening file?
          raise ascanner,'nodold: '+line
      s.send("QUIT\n")
      r=f.readline()
      s.shutdown(2)
      s.close()
      if ret==[]:
        vir=''
      else:
        vir=string.rstrip(ret[0])
      return vir,ret
